// Generated by CoffeeScript 1.12.6
(function() {
  var Signature, Tools, _, assert, debuglog, deleteByIds, insert, path, update, urlUtil;

  debuglog = require('debug')('ali-opensearch::models::actions');

  assert = require("assert");

  _ = require("underscore");

  urlUtil = require('url');

  path = require('path');

  Signature = require("../utils/signature");

  Tools = require('../utils/tools');

  insert = function(items, table_name, callback) {
    var header, i, len, query, uri, url, val;
    if (_.isEmpty(items)) {
      return callback('missing items');
    }
    assert(table_name, "missing table_name");
    assert(_.isFunction(callback), "missing callback");
    uri = path.join(this.URI_PREFIX, this.appName, table_name, "/actions/bulk");
    url = urlUtil.resolve(this.apiURL, uri);
    query = [];
    for (i = 0, len = items.length; i < len; i++) {
      val = items[i];
      query.push({
        cmd: 'add',
        fields: val
      });
    }
    query = JSON.stringify(query);
    header = Tools.generateHeader();
    header['Content-MD5'] = Signature.md5(query);
    header.Authorization = Signature.generateAuthorization(this.POST_HTTP_METHOD, uri, header);
    this.apiCall(url, this.POST_HTTP_METHOD, header, query, callback);
  };

  update = function(items, table_name, callback) {
    var header, i, len, query, uri, url, val;
    if (_.isEmpty(items)) {
      return callback('missing items');
    }
    assert(table_name, "missing table_name");
    assert(_.isFunction(callback), "missing callback");
    uri = path.join(this.URI_PREFIX, this.appName, table_name, "/actions/bulk");
    url = urlUtil.resolve(this.apiURL, uri);
    query = [];
    for (i = 0, len = items.length; i < len; i++) {
      val = items[i];
      query.push({
        cmd: 'update',
        fields: val
      });
    }
    query = JSON.stringify(query);
    header = Tools.generateHeader();
    header['Content-MD5'] = Signature.md5(query);
    header['Authorization'] = Signature.generateAuthorization(this.POST_HTTP_METHOD, uri, header);
    this.apiCall(url, this.POST_HTTP_METHOD, header, query, callback);
  };

  deleteByIds = function(ids, table_name, callback) {
    var header, query, uri, url;
    if (_.isEmpty(ids)) {
      return callback('missing ids');
    }
    assert(table_name, "missing table_name");
    assert(_.isFunction(callback), "missing callback");
    uri = path.join(this.URI_PREFIX, this.appName, table_name, "/actions/bulk");
    url = urlUtil.resolve(this.apiURL, uri);
    query = [];
    ids.map(function(val) {
      if (_.isObject(val)) {
        return query.push({
          cmd: 'delete',
          fields: val
        });
      } else {
        return query.push({
          cmd: 'delete',
          fields: {
            id: val
          }
        });
      }
    });
    query = JSON.stringify(query);
    header = Tools.generateHeader();
    header['Content-MD5'] = Signature.md5(query);
    header['Authorization'] = Signature.generateAuthorization(this.POST_HTTP_METHOD, uri, header);
    this.apiCall(url, this.POST_HTTP_METHOD, header, query, callback);
  };

  module.exports = {
    insert: insert,
    update: update,
    deleteByIds: deleteByIds
  };

}).call(this);
