// Generated by CoffeeScript 1.12.6
(function() {
  var Signature, Tools, _, advancedSearch, assert, debuglog, path, search, searchById, searchByMultipleId, urlUtil;

  debuglog = require('debug')('ali-opensearch::models::actions');

  assert = require("assert");

  _ = require("underscore");

  urlUtil = require('url');

  path = require('path');

  Signature = require("../utils/signature");

  Tools = require('../utils/tools');

  searchById = function(id, fields, format, callback) {
    var header, options, params, uri, url;
    params = {};
    fields = Tools.makeFields(fields);
    if (fields != null) {
      params['fetch_fields'] = fields;
    }
    params['query'] = "config=format:" + (format || 'json') + ",start:0,hit:" + this.pageSize + "&&query=id:'" + id + "'";
    header = Tools.generateHeader();
    uri = Tools.generateUri(path.join(this.URI_PREFIX, this.appName, "/search"), params);
    header['Authorization'] = Signature.generateAuthorization(this.GET_HTTP_METHOD, uri, header);
    url = urlUtil.resolve(this.apiURL, uri);
    options = {
      url: url,
      method: this.GET_HTTP_METHOD,
      timeout: this.timeout
    };
    this.apiCall(url, this.GET_HTTP_METHOD, header, null, callback);
  };

  searchByMultipleId = function(ids, fields, filter, format, callback) {
    var header, options, params, queryStr, uri, url;
    queryStr = Tools.makeMultipleIdStr(ids);
    params = {};
    fields = Tools.makeFields(fields);
    if (fields != null) {
      params['fetch_fields'] = fields;
    }
    params['query'] = "config=format:" + (format || 'json') + "&&query=" + queryStr;
    header = Tools.generateHeader();
    uri = Tools.generateUri(path.join(this.URI_PREFIX, this.appName, "/search"), params);
    header['Authorization'] = Signature.generateAuthorization(this.GET_HTTP_METHOD, uri, header);
    url = urlUtil.resolve(this.apiURL, uri);
    options = {
      url: url,
      method: this.GET_HTTP_METHOD,
      timeout: this.timeout
    };
    this.apiCall(url, this.GET_HTTP_METHOD, header, null, callback);
  };

  search = function(query, fields, filter, config, sort, aggregate, distinct, summary, callback) {
    var header, options, params, uri, url;
    if (query == null) {
      return callback('missing query');
    }
    params = {};
    fields = Tools.makeFields(fields);
    if (fields != null) {
      params['fetch_fields'] = fields;
    }
    params['query'] = "config=" + (Tools.makeConfig(config, this.pageSize)) + "&&query=" + query;
    if (filter != null) {
      params['query'] += "&&filter=" + filter;
    }
    if (sort != null) {
      params['query'] += "&&sort=" + sort;
    }
    if (aggregate != null) {
      params['query'] += "&&aggegate=" + aggregate;
    }
    if (distinct != null) {
      params['query'] += "&&distnct=" + distinct;
    }
    if (summary != null) {
      params['summary'] = Tools.makeSummary(summary);
    }
    header = Tools.generateHeader();
    uri = Tools.generateUri(path.join(this.URI_PREFIX, this.appName, "/search"), params);
    header['Authorization'] = Signature.generateAuthorization(this.GET_HTTP_METHOD, uri, header);
    url = urlUtil.resolve(this.apiURL, uri);
    options = {
      url: url,
      method: this.GET_HTTP_METHOD,
      timeout: this.timeout
    };
    this.apiCall(url, this.GET_HTTP_METHOD, header, null, callback);
  };

  advancedSearch = function(query, fields, summary, qp, disable, first_rank_name, second_rank_name, callback) {
    var header, options, params, uri, url;
    query = Tools.makeQuery(query, this.pageSize);
    if (query == null) {
      return callback('missing query');
    }
    params = {};
    fields = Tools.makeFields(fields);
    if (fields != null) {
      params['fetch_fields'] = fields;
    }
    params['query'] = query;
    if (qp != null) {
      params['qp'] = qp;
    }
    if (disable != null) {
      params['disable'] = disable;
    }
    if (first_rank_name != null) {
      params['first_rank_name'] = first_rank_name;
    }
    if (second_rank_name != null) {
      params['second_rank_name'] = second_rank_name;
    }
    if (summary != null) {
      params['summary'] = Tools.makeSummary(summary);
    }
    header = Tools.generateHeader();
    uri = Tools.generateUri(path.join(this.URI_PREFIX, this.appName, "/search"), params);
    header['Authorization'] = Signature.generateAuthorization(this.GET_HTTP_METHOD, uri, header);
    url = urlUtil.resolve(this.apiURL, uri);
    options = {
      url: url,
      method: this.GET_HTTP_METHOD,
      timeout: this.timeout
    };
    this.apiCall(url, this.GET_HTTP_METHOD, header, null, callback);
  };

  module.exports = {
    search: search,
    searchById: searchById,
    searchByMultipleId: searchByMultipleId,
    advancedSearch: advancedSearch
  };

}).call(this);
