// Generated by CoffeeScript 1.12.6
(function() {
  var ACCESS_KEY_ID, ACCESS_KEY_SECRET, crypto, debuglog, exports, generateAuthorization, getAuthorization, init, makeSignature, md5;

  debuglog = require('debug')('ali-opensearch::utils::signature');

  crypto = require('crypto');

  ACCESS_KEY_ID = null;

  ACCESS_KEY_SECRET = null;

  init = function(accessKeyId, accessKeySecret) {
    ACCESS_KEY_ID = accessKeyId;
    return ACCESS_KEY_SECRET = accessKeySecret;
  };

  md5 = function(str) {
    var md5sum, ref;
    md5sum = crypto.createHash('md5');
    md5sum.update(str, (ref = Buffer.isBuffer(str)) != null ? ref : {
      'binary': 'utf8'
    });
    return md5sum.digest('hex');
  };

  makeSignature = function(mothed, uri, request_header) {
    var params;
    params = [mothed];
    params.push(request_header['Content-MD5'] || '');
    params.push(request_header['Content-Type']);
    params.push(request_header['Date']);
    params.push("x-opensearch-nonce:" + request_header['X-Opensearch-Nonce']);
    params.push(uri);
    debuglog("[makeSignature] %j", params);
    return crypto.createHmac('sha1', ACCESS_KEY_SECRET).update(params.join('\n'), 'utf8').digest().toString('base64');
  };

  generateAuthorization = function(mothed, uri, request_header) {
    return "OPENSEARCH " + ACCESS_KEY_ID + ":" + (makeSignature(mothed, uri, request_header));
  };

  getAuthorization = function(signature) {
    return "OPENSEARCH " + ACCESS_KEY_ID + ":" + signature;
  };

  module.exports = exports = {
    init: init,
    md5: md5,
    makeSignature: makeSignature,
    generateAuthorization: generateAuthorization,
    getAuthorization: getAuthorization
  };

}).call(this);
